//
//  RAAtomicListTest.m
//  AudioHijackKit2
//
//  Created by Michael Ash on 11/9/08.
//  Copyright 2008 Rogue Amoeba Software, LLC. All rights reserved.
//

#import "RAAtomicListTest.h"


@implementation RAAtomicListTest

- (void)testThreaded
{
	[NSThread detachNewThreadSelector: @selector( _threadedEnqueue ) toTarget: self withObject: nil];
	[NSThread detachNewThreadSelector: @selector( _threadedEnqueue ) toTarget: self withObject: nil];
	
	unsigned count = 0;
	unsigned nohitcount = 0;
	RAAtomicListRef list;
	while( nohitcount < 25 )
	{
		while( (list = RAAtomicListSteal( &_list )) )
		{
			nohitcount = 0;
			RAAtomicListReverse( &list );
			while( RAAtomicListPop( &list ) )
				count++;
		}
		
		nohitcount++;
		if( nohitcount > 1 )
			usleep( 1000 );
	}
	
	STAssertEquals( count, 20000U, @"Bad number of objects dequeued!" );
	STAssertEquals( list, (RAAtomicListRef)NULL, @"Items remain on local list" );
	STAssertEquals( _list, (RAAtomicListRef)NULL, @"Items remain on shared list" );
}

- (void)_threadedEnqueue
{
	int i;
	for( i = 0; i < 10000; i++ )
		RAAtomicListInsert( &_list, self );
}

@end
