//
//  RAOperationQueueTest.m
//  AudioHijackKit2
//
//  Created by Michael Ash on 11/10/08.
//  Copyright 2008 Rogue Amoeba Software, LLC. All rights reserved.
//

#import "RAOperationQueueTest.h"

#import <libkern/OSAtomic.h>

#import "RAOperation.h"
#import "RAOperationQueue.h"


@implementation RAOperationQueueTest

- (void)testCounts
{
	_counter = 0;
	
	RAOperationQueue *queue = [[RAOperationQueue alloc] init];
	
	int i;
	for( i = 0; i < 10000; i++ )
		[queue addOperation: [[[RASelectorOperation alloc] initWithTarget: self
																 selector: @selector( _incrementCounter )
																   object: nil] autorelease]];
	RAWaitableSelectorOperation *op = [[RAWaitableSelectorOperation alloc] initWithTarget: self
																				 selector: @selector( _incrementCounter )
																				   object: nil];
	[queue addOperation: op];
	[op waitUntilDone];
	[op release];
	
	STAssertEquals( _counter, 10001, @"Bad operation count" );
	
	[queue release];
}

- (void)_incrementCounter
{
	OSAtomicIncrement32( &_counter );
}

@end
